include \masm32\include\masm32rt.inc

EolMode	equ 13, 10
; EolMode	equ 32,32,32,32		; for horizontal display

mbDebug MACRO slot:REQ, txt_title:REQ, args:VARARG
 pushad
 pushfd
 ifndef mbDebugbuff
	.data?
	mbDebugbuff	db 2048 dup (?)
	.data
	mbDebugbptr	dd mbDebugbuff
	mbDebugStop	dd 5 dup (IDOK)
	.code
 endif
 push offset mbDebugbuff
 pop mbDebugbptr
 mov byte ptr mbDebugbuff, 0
 for arg, <args>
	LOCAL tmp$, cc
	cc INSTR <arg>, <$>
	pushad
	tmp$ CATSTR <chr$(">, <arg>, <")>
	if cc
		mov mbDebugbptr, cat$(mbDebugbptr, tmp$, chr$(9), <arg>, chr$(EolMode))
	else
		mov mbDebugbptr, cat$(mbDebugbptr, tmp$, chr$(9), sstr$(arg), chr$(EolMode))
	endif
	popad
 ENDM
 .if mbDebugStop+4*slot==IDOK
	invoke MessageBox, 0, addr mbDebugbuff, reparg(txt_title), MB_OKCANCEL
 .endif
 mov mbDebugStop+4*slot, eax
 popfd
 popad
ENDM

.code

txMyPath	db "MulDbgMacro.asm", 0
txMyGreets	db 13,10,10, "Thanks to JimG for the ", 34, "fine tuning", 34, " ;-)", 0
MyFilePath$	dd txMyPath
MyGreets$	dd txMyGreets

start:

    call main
    exit

main proc
    LOCAL MyCounter:DWORD, My2ndVar:DWORD, MyThirdVar:DWORD
    mov MyCounter, 111
    mov My2ndVar, 222
    mov MyThirdVar, 333
    .While MyCounter>0
	pushad
	mov eax, 1000001
	mov ecx, 1000002
	mov edx, 1000003
	mov esi, 1000004
	mov edi, 1000005
	mov ebx, 1000006
	mbDebug 0, "Show me the registers and five variables:", \
	eax, ecx, edx, esi, edi, ebx, ebp, esp, \
	MyCounter, MyThirdVar, MyFilePath$, MyGreets$
	dec MyCounter
	mbDebug 1, "Show me the vars:", MyCounter, MyThirdVar, MyFilePath$
	popad
    .Endw
    ret

main endp
end start

OPT_DelTmp	0
OPT_Icon	Eye
OPT_Tmp2Asm	1
